/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/

#pragma warning( disable : 4518 )

// -*- C++ -*-
//
// $Id: otif_impl.cpp,v 1.1 2004/02/12 21:14:51 lang Exp $

// ****  Code generated by the The ACE ORB (TAO) IDL Compiler ****
// TAO and the TAO IDL Compiler have been developed by:
//       Center for Distributed Object Computing
//       Washington University
//       St. Louis, MO
//       USA
//       http://www.cs.wustl.edu/~schmidt/doc-center.html
// and
//       Distributed Object Computing Laboratory
//       University of California at Irvine
//       Irvine, CA
//       USA
//       http://doc.ece.uci.edu/
//
// Information about TAO is available at:
//     http://www.cs.wustl.edu/~schmidt/TAO.html

#include "otif_impl.h"
#include "backpanel.h"

// Implementation skeleton constructor
OTIF_Backplane_i::OTIF_Backplane_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_Backplane_i::~OTIF_Backplane_i (void)
  {
  }
  
::OTIF::NameVersion * OTIF_Backplane_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
{
  // Add your implementation here
	OTIF::NameVersion_var name = new OTIF::NameVersion();
	int error_code = _getBackplaneName(name);
	return name._retn();
}

::OTIF::NameVersion_S * OTIF_Backplane_i::Paradigms (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    OTIF::NameVersion_S_var names = new OTIF::NameVersion_S();
    int error_code = _getParadigms(names);
    return names._retn();
  }
  
::OTIF::TranslatorVersion_S * OTIF_Backplane_i::Translators (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
	OTIF::TranslatorVersion_S_var translators = new OTIF::TranslatorVersion_S();
	int error_code = _getTranslators(translators);
	return translators._retn();
  }
  
::OTIF::DocumentInfo_S * OTIF_Backplane_i::Documents (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
	OTIF::DocumentInfo_S_var datanetworks = new OTIF::DocumentInfo_S();
	int error_code = _getDocuments(datanetworks);
	return datanetworks._retn();
  }

::OTIF::Name_S * OTIF_Backplane_i::ToolAdaptorTypes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
	OTIF::Name_S_var types = new OTIF::Name_S();
	int error_code = _getToolAdaptorTypes(types);
	return types._retn();
  }

void OTIF_Backplane_i::lockParadigm (
    const OTIF::NameVersion & paradigm
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidParadigm,
    OTIF::ParadigmLocked
  ))

  {
    //Add your implementation here
    int error_code = _lockParadigm(paradigm);
    switch (error_code) {
    case 1 : throw OTIF::InvalidParadigm();
    case 2 : throw OTIF::ParadigmLocked();
    }
  }
  
::OTIF::Diagram_ptr OTIF_Backplane_i::fetchParadigm (
    const OTIF::NameVersion & paradigm
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidParadigm
  ))

  {
    //Add your implementation here
    OTIF::Diagram_var diagram;
    int error_code = _fetchParadigm(paradigm, diagram);
    switch (error_code) {
    case 1 : throw OTIF::InvalidParadigm();
    }
    return diagram._retn();
  }
  
void OTIF_Backplane_i::fetchRootTypeName (
    OTIF::DocumentID docId,
    CORBA::String_out rootTypeName
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidDocument
  ))

  {
    //Add your implementation here
	int error_code = _getDocumentRootObjectMeta(docId, rootTypeName);
	switch(error_code) {
    case 1 : throw OTIF::InvalidDocument();
	}
  }

void OTIF_Backplane_i::unlockParadigm (
    const OTIF::NameVersion & paradigm
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidParadigm,
    OTIF::ParadigmNotLocked
  ))

  {
    //Add your implementation here
    int error_code = _unlockParadigm(paradigm);
    switch (error_code) {
    case 1 : throw OTIF::InvalidParadigm();
    case 2 : throw OTIF::ParadigmNotLocked();
    }
  }
  
::OTIF::ManagerSession_ptr OTIF_Backplane_i::loginManager (
    const char * password,
    OTIF::SessionId_out session_id
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidPassword,
    OTIF::OnlyOneManager
  ))

  {
    //Add your implementation here
    OTIF::ManagerSession_var manager;
    int error_code = _loginManager(password, manager, session_id);
    switch (error_code) {
    case 1 : throw OTIF::InvalidPassword();
    case 2 : throw OTIF::OnlyOneManager();
    }
    return manager._retn();
  }
  
void OTIF_Backplane_i::logoutManager (
    CORBA::Long session_id
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidSession
  ))

  {
    //Add your implementation here
	int error_code = _logoutManager(session_id);
    switch (error_code) {
    case 1 : throw OTIF::InvalidSession();
    }
  }
  
::OTIF::ToolAdaptorSession_ptr OTIF_Backplane_i::loginToolAdaptor (
    const char * taType,
    CORBA::Long_out session_id
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidToolAdaptorType
  ))

  {
    //Add your implementation here
	OTIF::ToolAdaptorSession_var tooladaptor;
	int error_code = _loginToolAdaptor(taType, tooladaptor, session_id);
    switch (error_code) {
    case 1 : throw OTIF::InvalidToolAdaptorType();
    }
	return tooladaptor._retn();
  }
  
/*
::OTIF::NameVersion_S * OTIF_Backplane_i::getParadigmsOfToolAdaptorType (
    CORBA::Long session_id
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidSession
  ))
  {
    // Add your implementation here
    OTIF::NameVersion_S_var paradigms = new OTIF::NameVersion_S();
    int error_code = _getParadigmsOfToolAdaptorType(session_id, paradigms);
	switch (error_code) {
	case 1 : throw OTIF::InvalidSession();
	}
    return paradigms._retn();
  }
*/

::OTIF::ToolAdaptorInfo * OTIF_Backplane_i::getToolAdaptorInfoByType (
    const char * taType
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidToolAdaptorType
  ))
{
  // Add your implementation here
    OTIF::ToolAdaptorInfo_var ta_info = new OTIF::ToolAdaptorInfo();
    int error_code = _getToolAdaptorInfoByType(taType, ta_info);
	switch (error_code) {
	case 1 : throw OTIF::InvalidToolAdaptorType();
	}
    return ta_info._retn();
}

// TAO_IDL - Generated from
// D:\ACE_wrappers\TAO\TAO_IDL\be\be_visitor_operation/operation_is.cpp:57

::OTIF::ToolAdaptorInfo * OTIF_Backplane_i::getToolAdaptorInfo (
    OTIF::SessionId session_id
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidSession
  ))
{
  // Add your implementation here
    OTIF::ToolAdaptorInfo_var ta_info = new OTIF::ToolAdaptorInfo();
    int error_code = _getToolAdaptorInfo(session_id, ta_info);
	switch (error_code) {
	case 1 : throw OTIF::InvalidSession();
	}
    return ta_info._retn();
}

// TAO_IDL - Generated from
// D:\ACE_wrappers\TAO\TAO_IDL\be\be_visitor_operation/operation_is.cpp:57

char * OTIF_Backplane_i::getToolAdaptorType (
    const OTIF::NameVersion & paradigm,
    OTIF::taMode mode
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidParadigm
  ))
{
  // Add your implementation here
	string type = "";
	int error_code = _getToolAdaptorType(paradigm, mode, type);
	switch (error_code) {
	case 1 : throw OTIF::InvalidParadigm();
	}
	return CORBA::string_dup( type.c_str() );
}

void OTIF_Backplane_i::logoutToolAdaptor (
    CORBA::Long session_id
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidSession
  ))

  {
    //Add your implementation here
	int error_code = _logoutToolAdaptor(session_id);
    switch (error_code) {
    case 1 : throw OTIF::InvalidSession();
    }
  }
  
void OTIF_Backplane_i::now (
    OTIF::timeStamp_out stamp
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
	_now(stamp);
  }
  
void OTIF_Backplane_i::uploadStartup (
    const char * url
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
	int error_code = _uploadStartup(url);
	switch (error_code) {
	case 1 : throw OTIF::InvalidStartupFile();
	}
  }


// Implementation skeleton constructor
OTIF_ManagerSession_i::OTIF_ManagerSession_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_ManagerSession_i::~OTIF_ManagerSession_i (void)
  {
  }
  
void OTIF_ManagerSession_i::destroyDocument (
    OTIF::DocumentID docId
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidDocument
  ))
  {
    // Add your implementation here
    int error_code = _destroyDocument(docId);
    switch (error_code) {
    case 1 : throw OTIF::InvalidDocument();
    }
  }
  
void OTIF_ManagerSession_i::modifyDocumentName (
    OTIF::DocumentID docId,
    const char * name
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidDocument
  ))
  {
    // Add your implementation here
    int error_code = _modifyDocumentName(docId, name);
    switch (error_code) {
    case 1 : throw OTIF::InvalidDocument();
    }
  }
  
void OTIF_ManagerSession_i::modifyDocumentVersion (
    OTIF::DocumentID docId,
    const char * version
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidDocument
  ))
  {
    // Add your implementation here
    int error_code = _modifyDocumentVersion(docId, version);
    switch (error_code) {
    case 1 : throw OTIF::InvalidDocument();
    }
  }
  
void OTIF_ManagerSession_i::modifyDocumentRemarks (
    OTIF::DocumentID docId,
    const char * remarks
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidDocument
  ))
  {
    // Add your implementation here
    int error_code = _modifyDocumentRemarks(docId, remarks);
    switch (error_code) {
    case 1 : throw OTIF::InvalidDocument();
	}
  }
  
void OTIF_ManagerSession_i::modifyDocumentKeepAlive (
    OTIF::DocumentID docId,
    CORBA::Long keepAlive
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidDocument
  ))
  {
    // Add your implementation here
    int error_code = _modifyDocumentKeepAlive(docId, keepAlive);
    switch (error_code) {
    case 1 : throw OTIF::InvalidDocument();
	}
  }

::OTIF::Diagram_ptr OTIF_ManagerSession_i::registerMetaModel (
    const OTIF::NameVersion & paradigm,
    const OTIF::DataNetwork & metaData,
    OTIF::ManagerSession::RegistrationAction action
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::ParadigmExists,
    OTIF::ParadigmLocked,
    OTIF::ParadigmInUse
  ))

  {
    //Add your implementation here
    OTIF::Diagram_var diagram;
	int error_code = _registerMetaModel(paradigm, metaData, action, diagram);
    switch (error_code) {
    case 1 : throw OTIF::ParadigmExists();
    case 2 : throw OTIF::ParadigmLocked();
    case 3 : throw OTIF::ParadigmInUse();
    }
    return diagram._retn();
  }
  
::OTIF::Diagram_ptr OTIF_ManagerSession_i::registerMetaModelURL (
    const OTIF::NameVersion & paradigm,
    const char * url,
    OTIF::ManagerSession::RegistrationAction action
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::ParadigmExists,
    OTIF::ParadigmLocked,
    OTIF::ParadigmInUse,
	OTIF::InvalidFile
  ))

  {
	//Add your implementation here
    OTIF::Diagram_var diagram;
	int error_code = _registerMetaModelFile(paradigm, url, action, diagram);
    switch (error_code) {
    case 1 : throw OTIF::ParadigmExists();
    case 2 : throw OTIF::ParadigmLocked();
    case 3 : throw OTIF::ParadigmInUse();
    case 4 : throw OTIF::InvalidFile();
	}
    return diagram._retn();
  }
  
void OTIF_ManagerSession_i::unregisterMetaModel (
    const OTIF::NameVersion & paradigm
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::ParadigmInUse,
    OTIF::ParadigmLocked,
    OTIF::InvalidParadigm
  ))

  {
    //Add your implementation here
    int error_code = _unregisterMetaModel(paradigm);
    switch (error_code) {
    case 1 : throw OTIF::ParadigmInUse();
    case 2 : throw OTIF::ParadigmLocked();
    case 3 : throw OTIF::InvalidParadigm();
	}
  }

void OTIF_ManagerSession_i::registerTranslator (
    const OTIF::TranslatorVersion & translator,
    const char * activation,
    OTIF::ManagerSession::RegistrationAction action
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::TranslatorExists,
    OTIF::TranslatorInUse,
    OTIF::InvalidTranslator,
    OTIF::InvalidParadigm
  ))

  {
    //Add your implementation here
	int error_code = _registerTranslator(translator, activation, action);
    switch (error_code) {
    case 1 : throw OTIF::TranslatorExists();
    case 2 : throw OTIF::TranslatorInUse();
	case 3 : throw OTIF::InvalidTranslator();
	case 4 : throw OTIF::InvalidParadigm();
	}
  }
  
void OTIF_ManagerSession_i::unregisterTranslator (
    const OTIF::TranslatorVersion & translator
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::TranslatorInUse,
    OTIF::InvalidTranslator
  ))

  {
    //Add your implementation here
	int error_code = _unregisterTranslator(translator);
    switch (error_code) {
    case 1 : throw OTIF::TranslatorInUse();
	case 2 : throw OTIF::InvalidTranslator();
	}
  }
  
void OTIF_ManagerSession_i::changePassword (
    const char * old_password,
    const char * new_password
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidPassword
  ))

  {
    //Add your implementation here
	int error_code = _change_password(old_password, new_password);
	switch (error_code) {
	case 1 : throw OTIF::InvalidPassword();
	}
  }

void OTIF_ManagerSession_i::shutdown (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
	_shutdown();
  }
  
// Implementation skeleton constructor
OTIF_ToolAdaptorNotifyCallback_i::OTIF_ToolAdaptorNotifyCallback_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_ToolAdaptorNotifyCallback_i::~OTIF_ToolAdaptorNotifyCallback_i (void)
  {
  }
  
void OTIF_ToolAdaptorNotifyCallback_i::notify (
    const OTIF::NameVersion & documentName,
    const char * remarks,
    OTIF::DocumentID docId,
    CORBA::Long keepAlive
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
  }

void OTIF_ToolAdaptorNotifyCallback_i::changedExistingDocument (
    const OTIF::NameVersion & documentName,
    const char * remarks,
    OTIF::DocumentID docId,
    CORBA::Long keepAlive
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
  }

// Implementation skeleton constructor
OTIF_ToolAdaptorSession_i::OTIF_ToolAdaptorSession_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_ToolAdaptorSession_i::~OTIF_ToolAdaptorSession_i (void)
	  {
  }
  
OTIF::DocumentID OTIF_ToolAdaptorSession_i::publishDocument (
    OTIF::SessionId session_id,
    const OTIF::NameVersion & documentName,
    const char * remarks,
    CORBA::Long keepAlive,
    const OTIF::Document & docData,
    OTIF::DocumentID previous_docId
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidParadigm
    , OTIF::InvalidSession
	, OTIF::InvalidDocument
  ))

  {
    //Add your implementation here
	OTIF::DocumentID document_id;
	int error_code = _publishDocument(session_id, documentName, remarks, keepAlive, docData, previous_docId, document_id);
	switch(error_code) {
    case 1 : throw OTIF::InvalidParadigm();
    case 2 : throw OTIF::InvalidSession();
    case 3 : throw OTIF::InvalidDocument();
	}

	return document_id;
  }
  
void OTIF_ToolAdaptorSession_i::subscribe (
    CORBA::Long session_id,
    OTIF::ToolAdaptorNotifyCallback_ptr callback
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidParadigm
    , OTIF::InvalidSession
  ))

  {
    //Add your implementation here
	int error_code = _subscribe(session_id, callback);
	switch(error_code) {
    case 1 : throw OTIF::InvalidParadigm();
    case 2 : throw OTIF::InvalidSession();
	}
  }
  
::OTIF::Document * OTIF_ToolAdaptorSession_i::fetchDocument (
    OTIF::DocumentID docId
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidDocument
  ))

  {
    //Add your implementation here
    OTIF::Document_var docData;
    int error_code = _fetchDocument(docId, docData);
    switch(error_code) {
    case 1 : throw OTIF::InvalidDocument();
	}
	return docData._retn();
  }
  
::OTIF::DocumentInfo_S * OTIF_ToolAdaptorSession_i::getDocuments (
    OTIF::SessionId session_id
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidSession
  ))
{
  // Add your implementation here
	OTIF::DocumentInfo_S_var datanetworks = new OTIF::DocumentInfo_S();
	int error_code = _getToolAdaptorDocuments(session_id, datanetworks);
	return datanetworks._retn();
}

::OTIF::NameVersion * OTIF_ToolAdaptorSession_i::getDocumentParadigmName (
    OTIF::DocumentID docId
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidDocument
  ))
  {
    // Add your implementation here
	OTIF::NameVersion_var paradigm = new OTIF::NameVersion();
	int error_code = _getDocumentParadigm(docId, paradigm);
	switch(error_code) {
	case 1 : throw OTIF::InvalidDocument();
	}
	return paradigm._retn();
  }

::OTIF::ToolAdaptorInfo * OTIF_ToolAdaptorSession_i::getToolAdaptorInfo (
    OTIF::SessionId session_id
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidSession
  ))
{
  // Add your implementation here
	OTIF::ToolAdaptorInfo_var ta_info = new OTIF::ToolAdaptorInfo();
    int error_code = _getToolAdaptorInfo(session_id, ta_info);
	switch (error_code) {
	case 1 : throw OTIF::InvalidSession();
	}
    return ta_info._retn();
}

// Implementation skeleton constructor
OTIF_TranslatorNotifyCallback_i::OTIF_TranslatorNotifyCallback_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_TranslatorNotifyCallback_i::~OTIF_TranslatorNotifyCallback_i (void)
  {
  }
  
void OTIF_TranslatorNotifyCallback_i::notify (
    const OTIF::NameVersion & documentName,
    OTIF::DocumentID docId,
    CORBA::Long keepAlive,
    CORBA::Long numberOfDocuments
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
  }
  
// Implementation skeleton constructor
OTIF_TranslatorFeed_i::OTIF_TranslatorFeed_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_TranslatorFeed_i::~OTIF_TranslatorFeed_i (void)
  {
  }
  
void OTIF_TranslatorFeed_i::subscribe (
    OTIF::TranslatorNotifyCallback_ptr callback
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidSession
  ))

  {
    //Add your implementation here
	int error_code = _tf_subscribe(session_id, callback);
	switch(error_code) {
    case 1 : throw OTIF::InvalidSession();
	}

  }
  
::OTIF::Document * OTIF_TranslatorFeed_i::fetchDocument (
    OTIF::DocumentID docId
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException,
    OTIF::InvalidDocument
  ))

  {
    //Add your implementation here
    OTIF::Document_var docData;
    int error_code = _fetchDocument(docId, docData);
    switch(error_code) {
    case 1 : throw OTIF::InvalidDocument();
	}
	return docData._retn();
  }
  
// Implementation skeleton constructor
OTIF_TranslatorSink_i::OTIF_TranslatorSink_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_TranslatorSink_i::~OTIF_TranslatorSink_i (void)
  {
  }
  
void OTIF_TranslatorSink_i::publishDocument (
    const OTIF::NameVersion & documentName,
    const char * remarks,
    CORBA::Long keepAlive,
    const OTIF::Document & docData,
    OTIF::DocumentID source_docId
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
    , OTIF::InvalidSession
  ))

  {
    //Add your implementation here
	int error_code = _ts_publishDocument(session_id, documentName, remarks, keepAlive, docData, source_docId);
    switch(error_code) {
    case 1 : throw OTIF::InvalidSession();
	}
  }
  
