/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/

#pragma warning( disable : 4518 )

// -*- C++ -*-
//
// $Id: otifdata_impl.cpp,v 1.1 2004/02/12 21:14:51 lang Exp $

// ****  Code generated by the The ACE ORB (TAO) IDL Compiler ****
// TAO and the TAO IDL Compiler have been developed by:
//       Center for Distributed Object Computing
//       Washington University

//       St. Louis, MO
//       USA
//       http://www.cs.wustl.edu/~schmidt/doc-center.html
// and
//       Distributed Object Computing Laboratory
//       University of California at Irvine
//       Irvine, CA
//       USA
//       http://doc.ece.uci.edu/
//
// Information about TAO is available at:
//     http://www.cs.wustl.edu/~schmidt/TAO.html

#include "otifdata_impl.h"
#include "backpanel.h"

// Implementation skeleton constructor
OTIF_Diagram_i::OTIF_Diagram_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_Diagram_i::~OTIF_Diagram_i (void)
  {
    delete m_classes;
    delete m_associations;
    delete m_compositions;
  }
  
void OTIF_Diagram_i::set_id(CORBA::Long id) {
  m_id = id;
}
void OTIF_Diagram_i::set_name(const char *name) {
  m_name = CORBA::string_dup(name);
}
void OTIF_Diagram_i::set_version(const char *version) {
  m_version = CORBA::string_dup(version);
}
void OTIF_Diagram_i::set_classes(OTIF::Class_S *classes) {
  m_classes = classes;
}
void OTIF_Diagram_i::set_associations(OTIF::Association_S *associations) {
  m_associations = associations;
}
void OTIF_Diagram_i::set_compositions(OTIF::Composition_S *compositions) {
  m_compositions = compositions;
}

CORBA::Long OTIF_Diagram_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

char * OTIF_Diagram_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
char * OTIF_Diagram_i::version (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
{
  // Add your implementation here
    return CORBA::string_dup(m_version);
}

::OTIF::Composition_S * OTIF_Diagram_i::compositions (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::Composition_S(*m_compositions);
  }
  
::OTIF::Association_S * OTIF_Diagram_i::associations (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::Association_S(*m_associations);
  }
  
::OTIF::Class_S * OTIF_Diagram_i::classes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::Class_S(*m_classes);
  }
  
// Implementation skeleton constructor
OTIF_Composition_i::OTIF_Composition_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_Composition_i::~OTIF_Composition_i (void)
  {
  }
  
void OTIF_Composition_i::set_id(CORBA::Long id) {
  m_id = id;
}
void OTIF_Composition_i::set_name(const char *name) {
  m_name = CORBA::string_dup(name);
}
void OTIF_Composition_i::set_parent(OTIF::Diagram_var parent) {
  m_parent = parent;
}
void OTIF_Composition_i::set_nonpersistent(CORBA::Boolean nonpersistent) {
  m_nonpersistent = nonpersistent;
}
void OTIF_Composition_i::set_parentRole(OTIF::CompositionParentRole_var parentRole) {
  m_parentRole = parentRole;
}
void OTIF_Composition_i::set_childRole(OTIF::CompositionChildRole_var childRole) {
  m_childRole = childRole;
}

CORBA::Long OTIF_Composition_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

char * OTIF_Composition_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
::OTIF::Diagram_ptr OTIF_Composition_i::parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Diagram::_duplicate(m_parent);
  }
  
CORBA::Boolean OTIF_Composition_i::nonpersistent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_nonpersistent;
  }
  
::OTIF::CompositionParentRole_ptr OTIF_Composition_i::parentRole (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::CompositionParentRole::_duplicate(m_parentRole);
  }
  
::OTIF::CompositionChildRole_ptr OTIF_Composition_i::childRole (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::CompositionChildRole::_duplicate(m_childRole);
  }
  
// Implementation skeleton constructor
OTIF_GenericRole_i::OTIF_GenericRole_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_GenericRole_i::~OTIF_GenericRole_i (void)
  {
  }

void OTIF_GenericRole_i::set_id(CORBA::Long id) {
  m_id = id;
}
void OTIF_GenericRole_i::set_name(const char *name) {
  m_name = CORBA::string_dup(name);
}
void OTIF_GenericRole_i::set_isNavigable(CORBA::Boolean isNavigable) {
  m_isNavigable = isNavigable;
}
  
CORBA::Long OTIF_GenericRole_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

char * OTIF_GenericRole_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
CORBA::Boolean OTIF_GenericRole_i::isNavigable (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_isNavigable;
  }
  
// Implementation skeleton constructor
OTIF_CompositionParentRole_i::OTIF_CompositionParentRole_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_CompositionParentRole_i::~OTIF_CompositionParentRole_i (void)
  {
  }

void OTIF_CompositionParentRole_i::set_parent(OTIF::Composition_var parent) {
  m_parent = parent;
}
void OTIF_CompositionParentRole_i::set_target(OTIF::Class_var target) {
  m_target = target;
}
  
::OTIF::Composition_ptr OTIF_CompositionParentRole_i::parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Composition::_duplicate(m_parent);
  }
  
::OTIF::Class_ptr OTIF_CompositionParentRole_i::target (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Class::_duplicate(m_target);
  }
  
CORBA::Long OTIF_CompositionParentRole_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

char * OTIF_CompositionParentRole_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
CORBA::Boolean OTIF_CompositionParentRole_i::isNavigable (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_isNavigable;
  }
  
// Implementation skeleton constructor
OTIF_CompositionChildRole_i::OTIF_CompositionChildRole_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_CompositionChildRole_i::~OTIF_CompositionChildRole_i (void)
  {
  }

void OTIF_CompositionChildRole_i::set_parent(OTIF::Composition_var parent) {
  m_parent = parent;
}
void OTIF_CompositionChildRole_i::set_target(OTIF::Class_var target) {
  m_target = target;
}
void OTIF_CompositionChildRole_i::set_minCard(CORBA::Long minCard) {
  m_minCard = minCard;
}
void OTIF_CompositionChildRole_i::set_maxCard(CORBA::Long maxCard) {
  m_maxCard = maxCard;
}
  
::OTIF::Composition_ptr OTIF_CompositionChildRole_i::parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Composition::_duplicate(m_parent);
  }
  
::OTIF::Class_ptr OTIF_CompositionChildRole_i::target (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Class::_duplicate(m_target);
  }
  
CORBA::Long OTIF_CompositionChildRole_i::minCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_minCard;
  }
  
CORBA::Long OTIF_CompositionChildRole_i::maxCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_maxCard;
  }
  
CORBA::Long OTIF_CompositionChildRole_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

char * OTIF_CompositionChildRole_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
CORBA::Boolean OTIF_CompositionChildRole_i::isNavigable (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_isNavigable;
  }
  
// Implementation skeleton constructor
OTIF_AssociationRole_i::OTIF_AssociationRole_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_AssociationRole_i::~OTIF_AssociationRole_i (void)
  {
  }

void OTIF_AssociationRole_i::set_parent(OTIF::Association_var parent) {
  m_parent = parent;
}
void OTIF_AssociationRole_i::set_target(OTIF::Class_var target) {
  m_target = target;
}
void OTIF_AssociationRole_i::set_minCard(CORBA::Long minCard) {
  m_minCard = minCard;
}
void OTIF_AssociationRole_i::set_maxCard(CORBA::Long maxCard) {
  m_maxCard = maxCard;
}
void OTIF_AssociationRole_i::set_isPrimary(CORBA::Boolean isPrimary) {
  m_isPrimary = isPrimary;
}

::OTIF::Association_ptr OTIF_AssociationRole_i::parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Association::_duplicate(m_parent);
  }
  
::OTIF::Class_ptr OTIF_AssociationRole_i::target (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Class::_duplicate(m_target);
  }
  
CORBA::Long OTIF_AssociationRole_i::minCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_minCard;
  }
  
CORBA::Long OTIF_AssociationRole_i::maxCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_maxCard;
  }
  
CORBA::Boolean OTIF_AssociationRole_i::isPrimary (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_isPrimary;
  }
  
CORBA::Long OTIF_AssociationRole_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

char * OTIF_AssociationRole_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
CORBA::Boolean OTIF_AssociationRole_i::isNavigable (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_isNavigable;
  }
  
// Implementation skeleton constructor
OTIF_Association_i::OTIF_Association_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_Association_i::~OTIF_Association_i (void)
  {
    delete m_roles;
    delete m_tagValues;
  }

void OTIF_Association_i::set_id(CORBA::Long id) {
  m_id = id;
}
void OTIF_Association_i::set_parent(OTIF::Diagram_var parent) {
  m_parent = parent;
}
void OTIF_Association_i::set_name(const char *name) {
  m_name = CORBA::string_dup(name);
}
void OTIF_Association_i::set_nonpersistent(CORBA::Boolean nonpersistent) {
  m_nonpersistent = nonpersistent;
}
void OTIF_Association_i::set_roles(OTIF::AssociationRole_S *roles) {
  m_roles = roles;
}
void OTIF_Association_i::set_assocClass(OTIF::Class_var assocClass) {
  m_assocClass = assocClass;
}
void OTIF_Association_i::set_tagValues(OTIF::TaggedValue_S * tagValues) {
  m_tagValues = tagValues;
}

CORBA::Long OTIF_Association_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

  
::OTIF::Diagram_ptr OTIF_Association_i::parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Diagram::_duplicate(m_parent);
  }
  
char * OTIF_Association_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
CORBA::Boolean OTIF_Association_i::nonpersistent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_nonpersistent;
  }
  
::OTIF::AssociationRole_S * OTIF_Association_i::roles (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::AssociationRole_S(*m_roles);
  }
  
::OTIF::Class_ptr OTIF_Association_i::assocClass (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Class::_duplicate(m_assocClass);
  }
  
::OTIF::TaggedValue_S * OTIF_Association_i::tagValues (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::TaggedValue_S(*m_tagValues);
  }
  
// Implementation skeleton constructor
OTIF_TaggedValue_i::OTIF_TaggedValue_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_TaggedValue_i::~OTIF_TaggedValue_i (void)
  {
  }

void OTIF_TaggedValue_i::set_id(CORBA::Long id) {
  m_id = id;
}
void OTIF_TaggedValue_i::set_assocParent(OTIF::Association_var assocParent) {
  m_assocParent = assocParent;
}
void OTIF_TaggedValue_i::set_classParent(OTIF::Class_var classParent) {
  m_classParent = classParent;
}
void OTIF_TaggedValue_i::set_name(const char *name) {
  m_name = CORBA::string_dup(name);
}
void OTIF_TaggedValue_i::set_value(const char *value) {
  m_value = CORBA::string_dup(value);
}


CORBA::Long OTIF_TaggedValue_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

::OTIF::Association_ptr OTIF_TaggedValue_i::assocParent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Association::_duplicate(m_assocParent);
  }
  
::OTIF::Class_ptr OTIF_TaggedValue_i::classParent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Class::_duplicate(m_classParent);
  }
  
char * OTIF_TaggedValue_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
char * OTIF_TaggedValue_i::value (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_value);
  }
  
// Implementation skeleton constructor
OTIF_Attrib_i::OTIF_Attrib_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_Attrib_i::~OTIF_Attrib_i (void)
  {
    delete m_defvalue;
  }

void OTIF_Attrib_i::set_id(CORBA::Long id) {
  m_id = id;
}
void OTIF_Attrib_i::set_name(const char *name) {
  m_name = CORBA::string_dup(name);
}
void OTIF_Attrib_i::set_type(const char *type) {
  m_type = CORBA::string_dup(type);
}
void OTIF_Attrib_i::set_minCard(CORBA::Long minCard) {
  m_minCard = minCard;
}
void OTIF_Attrib_i::set_maxCard(CORBA::Long maxCard) {
  m_maxCard = maxCard;
}
void OTIF_Attrib_i::set_nonpersistent(CORBA::Boolean nonpersistent) {
  m_nonpersistent = nonpersistent;
}
void OTIF_Attrib_i::set_ordered(CORBA::Boolean ordered) {
  m_ordered = ordered;
}
void OTIF_Attrib_i::set_visibility(const char *visibility) {
  m_visibility = CORBA::string_dup(visibility);
}
void OTIF_Attrib_i::set_registry(CORBA::Boolean registry) {
  m_registry = registry;
}
void OTIF_Attrib_i::set_defvalue(OTIF::string_S *defvalue) {
  m_defvalue = defvalue;
}
void OTIF_Attrib_i::set_parent(OTIF::Class_var parent) {
  m_parent = parent;
}

  
CORBA::Long OTIF_Attrib_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

char * OTIF_Attrib_i::typeName (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_type);
  }
  
char * OTIF_Attrib_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
CORBA::Long OTIF_Attrib_i::minCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_minCard;
  }
  
CORBA::Long OTIF_Attrib_i::maxCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_maxCard;
  }
  
CORBA::Boolean OTIF_Attrib_i::nonpersistent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_nonpersistent;
  }

CORBA::Boolean OTIF_Attrib_i::ordered (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
    return m_ordered;
  }
  
char * OTIF_Attrib_i::visibility (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
    return CORBA::string_dup(m_visibility);
  }
  
CORBA::Boolean OTIF_Attrib_i::registry (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
    return m_registry;
  }


::OTIF::string_S * OTIF_Attrib_i::defvalue (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
    return new OTIF::string_S(*m_defvalue);
  }
  
::OTIF::Class_ptr OTIF_Attrib_i::parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Class::_duplicate(m_parent);
  }
  
// Implementation skeleton constructor
OTIF_Class_i::OTIF_Class_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_Class_i::~OTIF_Class_i (void)
  {
    delete m_parentRoles;
    delete m_childRoles;
    delete m_associationRoles;
    delete m_tagValues;
    delete m_attributes;
    delete m_baseTypes;
    delete m_subTypes;
  }
  
void OTIF_Class_i::set_id(CORBA::Long id) {
  m_id = id;
}
CORBA::Long OTIF_Class_i::get_id() {
  return m_id;
}
void OTIF_Class_i::set_name(const char *name) {
  m_name = CORBA::string_dup(name);
}
CORBA::String_var OTIF_Class_i::get_name() {
	return m_name;
}
void OTIF_Class_i::set_parent(OTIF::Diagram_var parent) {
  m_parent = parent;
}
void OTIF_Class_i::set_stereotype(const char *stereotype) {
  m_stereotype = CORBA::string_dup(stereotype);
}
void OTIF_Class_i::set_isAbstract(CORBA::Boolean isAbstract) {
  m_isAbstract = isAbstract;
}
void OTIF_Class_i::set_parentRoles(OTIF::CompositionParentRole_S *parentRoles) {
  m_parentRoles = parentRoles;
}
void OTIF_Class_i::set_childRoles(OTIF::CompositionChildRole_S *childRoles) {
  m_childRoles = childRoles;
}
void OTIF_Class_i::set_associationRoles(OTIF::AssociationRole_S *associationRoles) {
  m_associationRoles = associationRoles;
}
void OTIF_Class_i::set_assoc(OTIF::Association_var assoc) {
  m_assoc = assoc;
}
void OTIF_Class_i::set_tagValues(OTIF::TaggedValue_S *tagValues) {
  m_tagValues = tagValues;
}
void OTIF_Class_i::set_attributes(OTIF::Attrib_S *attributes) {
  m_attributes = attributes;
}
void OTIF_Class_i::set_baseTypes(OTIF::Class_S *baseTypes) {
  m_baseTypes = baseTypes;
}
void OTIF_Class_i::set_subTypes(OTIF::Class_S *subTypes) {
  m_subTypes = subTypes;
}


CORBA::Long OTIF_Class_i::tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_id;
  }

::OTIF::Diagram_ptr OTIF_Class_i::parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Diagram::_duplicate(m_parent);
  }
  
char * OTIF_Class_i::stereotypeName (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_stereotype);
  }
  
CORBA::Boolean OTIF_Class_i::isAbstract (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return m_isAbstract;
  }

char * OTIF_Class_i::name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return CORBA::string_dup(m_name);
  }
  
::OTIF::CompositionParentRole_S * OTIF_Class_i::parentRoles (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::CompositionParentRole_S(*m_parentRoles);
  }
  
::OTIF::CompositionChildRole_S * OTIF_Class_i::childRoles (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::CompositionChildRole_S(*m_childRoles);
  }
  
::OTIF::AssociationRole_S * OTIF_Class_i::associationRoles (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::AssociationRole_S(*m_associationRoles);
  }
  
::OTIF::Association_ptr OTIF_Class_i::assoc (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return OTIF::Association::_duplicate(m_assoc);
  }
  
::OTIF::TaggedValue_S * OTIF_Class_i::tagValues (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::TaggedValue_S(*m_tagValues);
  }
  
::OTIF::Attrib_S * OTIF_Class_i::attributes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::Attrib_S(*m_attributes);
  }
  
::OTIF::Class_S * OTIF_Class_i::baseTypes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::Class_S(*m_baseTypes);
  }
  
::OTIF::Class_S * OTIF_Class_i::subTypes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
    return new OTIF::Class_S(*m_subTypes);
  }
  
