/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/

// -*- C++ -*-
//
// $Id: otifdata_impl.h,v 1.1 2004/02/12 21:14:51 lang Exp $

// ****  Code generated by the The ACE ORB (TAO) IDL Compiler ****
// TAO and the TAO IDL Compiler have been developed by:
//       Center for Distributed Object Computing
//       Washington University
//       St. Louis, MO
//       USA
//       http://www.cs.wustl.edu/~schmidt/doc-center.html
// and
//       Distributed Object Computing Laboratory
//       University of California at Irvine
//       Irvine, CA
//       USA
//       http://doc.ece.uci.edu/
//
// Information about TAO is available at:
//     http://www.cs.wustl.edu/~schmidt/TAO.html

#ifndef ___BACKPANEL_UDMCORBAI_H_
#define ___BACKPANEL_UDMCORBAI_H_

#include "otifdataS.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
#pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

//Class OTIF_Diagram_i
class  OTIF_Diagram_i : public virtual POA_OTIF::Diagram
{
public:
  //Constructor 
  OTIF_Diagram_i (void);
  
  //Destructor 
  virtual ~OTIF_Diagram_i (void);
  
  void set_id(CORBA::Long id);
  void set_name(const char *name);
  void set_version(const char *version);
  void set_classes(OTIF::Class_S *classes);
  void set_associations(OTIF::Association_S *associations);
  void set_compositions(OTIF::Composition_S *compositions);

virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * version (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Composition_S * compositions (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Association_S * associations (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_S * classes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
  CORBA::Long m_id;
  CORBA::String_var m_name; 
  CORBA::String_var m_version; 
  OTIF::Class_S *m_classes;
  OTIF::Association_S *m_associations;
  OTIF::Composition_S *m_compositions;
};

//Class OTIF_Composition_i
class  OTIF_Composition_i : public virtual POA_OTIF::Composition
{
public:
  //Constructor 
  OTIF_Composition_i (void);
  
  //Destructor 
  virtual ~OTIF_Composition_i (void);

  void set_id(CORBA::Long id);
  void set_name(const char *name);
  void set_parent(OTIF::Diagram_var parent);
  void set_nonpersistent(CORBA::Boolean nonpersistent);
  void set_parentRole(OTIF::CompositionParentRole_var parentRole);
  void set_childRole(OTIF::CompositionChildRole_var childRole);
  
virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Diagram_ptr parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean nonpersistent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::CompositionParentRole_ptr parentRole (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::CompositionChildRole_ptr childRole (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
	CORBA::Long m_id;
  CORBA::String_var m_name;
  OTIF::Diagram_var m_parent;
  CORBA::Boolean m_nonpersistent;
  OTIF::CompositionParentRole_var m_parentRole;
  OTIF::CompositionChildRole_var m_childRole;

};

//Class OTIF_GenericRole_i
class  OTIF_GenericRole_i : public virtual POA_OTIF::GenericRole
{
public:
  //Constructor 
  OTIF_GenericRole_i (void);
  
  //Destructor 
  virtual ~OTIF_GenericRole_i (void);

  void set_id(CORBA::Long id);
  void set_name(const char *name);
  void set_isNavigable(CORBA::Boolean isNavigable);
  
virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean isNavigable (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

protected:
  CORBA::Long m_id;
  CORBA::String_var m_name;
  CORBA::Boolean m_isNavigable;
};

//Class OTIF_CompositionParentRole_i
class  OTIF_CompositionParentRole_i : public virtual POA_OTIF::CompositionParentRole,
					  public virtual OTIF_GenericRole_i
{
public:
  //Constructor 
  OTIF_CompositionParentRole_i (void);
  
  //Destructor 
  virtual ~OTIF_CompositionParentRole_i (void);

  void set_parent(OTIF::Composition_var parent);
  void set_target(OTIF::Class_var target);
  
virtual ::OTIF::Composition_ptr parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_ptr target (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean isNavigable (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
  OTIF::Composition_var m_parent;
  OTIF::Class_var m_target;
};

//Class OTIF_CompositionChildRole_i
class  OTIF_CompositionChildRole_i : public virtual POA_OTIF::CompositionChildRole,
					 public virtual OTIF_GenericRole_i
{
public:
  //Constructor 
  OTIF_CompositionChildRole_i (void);
  
  //Destructor 
  virtual ~OTIF_CompositionChildRole_i (void);

  void set_parent(OTIF::Composition_var parent);
  void set_target(OTIF::Class_var target);
  void set_minCard(CORBA::Long minCard);
  void set_maxCard(CORBA::Long maxCard);
  
virtual ::OTIF::Composition_ptr parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_ptr target (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long minCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long maxCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean isNavigable (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
  OTIF::Composition_var m_parent;
  OTIF::Class_var m_target;
  CORBA::Long m_minCard;
  CORBA::Long m_maxCard;

};

//Class OTIF_AssociationRole_i
class  OTIF_AssociationRole_i : public virtual POA_OTIF::AssociationRole,
				    public virtual OTIF_GenericRole_i
{
public:
  //Constructor 
  OTIF_AssociationRole_i (void);
  
  //Destructor 
  virtual ~OTIF_AssociationRole_i (void);

  void set_parent(OTIF::Association_var parent);
  void set_target(OTIF::Class_var target);
  void set_minCard(CORBA::Long minCard);
  void set_maxCard(CORBA::Long maxCard);
  void set_isPrimary(CORBA::Boolean isPrimary);
  
virtual ::OTIF::Association_ptr parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_ptr target (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long minCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long maxCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean isPrimary (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean isNavigable (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
  OTIF::Association_var m_parent;
  OTIF::Class_var m_target;
  CORBA::Long m_minCard;
  CORBA::Long m_maxCard;
  CORBA::Boolean m_isPrimary;

};

//Class OTIF_Association_i
class  OTIF_Association_i : public virtual POA_OTIF::Association
{
public:
  //Constructor 
  OTIF_Association_i (void);
  
  //Destructor 
  virtual ~OTIF_Association_i (void);

  void set_id(CORBA::Long id);
  void set_parent(OTIF::Diagram_var parent);
  void set_name(const char *name);
  void set_nonpersistent(CORBA::Boolean nonpersistent);
  void set_roles(OTIF::AssociationRole_S *roles);
  void set_assocClass(OTIF::Class_var assocClass);
  void set_tagValues(OTIF::TaggedValue_S * tagValues);
  
virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));
  
virtual ::OTIF::Diagram_ptr parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean nonpersistent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::AssociationRole_S * roles (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_ptr assocClass (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::TaggedValue_S * tagValues (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
	CORBA::Long m_id;
	OTIF::Diagram_var m_parent;
  CORBA::String_var m_name;
  CORBA::Boolean m_nonpersistent;
  OTIF::AssociationRole_S *m_roles;
  OTIF::Class_var m_assocClass;
  OTIF::TaggedValue_S *m_tagValues;

};

//Class OTIF_TaggedValue_i
class  OTIF_TaggedValue_i : public virtual POA_OTIF::TaggedValue
{
public:
  //Constructor 
  OTIF_TaggedValue_i (void);
  
  //Destructor 
  virtual ~OTIF_TaggedValue_i (void);

  void set_id(CORBA::Long id);
  void set_assocParent(OTIF::Association_var assocParent);
  void set_classParent(OTIF::Class_var classParent);
  void set_name(const char *name);
  void set_value(const char *value);

virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Association_ptr assocParent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_ptr classParent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * value (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
	CORBA::Long m_id;
  OTIF::Association_var m_assocParent;
  OTIF::Class_var m_classParent;
  CORBA::String_var m_name;
  CORBA::String_var m_value;

};

//Class OTIF_Attrib_i
class  OTIF_Attrib_i : public virtual POA_OTIF::Attrib
{
public:
  //Constructor 
  OTIF_Attrib_i (void);
  
  //Destructor 
  virtual ~OTIF_Attrib_i (void);
  
  void set_id(CORBA::Long id);
  void set_name(const char *name);
  void set_type(const char *type);
  void set_minCard(CORBA::Long minCard);
  void set_maxCard(CORBA::Long maxCard);
  void set_nonpersistent(CORBA::Boolean nonpersistent);
  void set_ordered(CORBA::Boolean ordered);
  void set_visibility(const char *visibility);
  void set_defvalue(OTIF::string_S *defvalue);
  void set_registry(CORBA::Boolean registry);
  void set_parent(OTIF::Class_var parent);


virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * typeName (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long minCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Long maxCard (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean nonpersistent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean ordered (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * visibility (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean registry (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::string_S * defvalue (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_ptr parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
  CORBA::Long m_id;
  CORBA::String_var m_name;
  CORBA::String_var m_type;
  CORBA::Long m_minCard;
  CORBA::Long m_maxCard;
  CORBA::Boolean m_nonpersistent;
  CORBA::Boolean m_ordered;
  CORBA::String_var m_visibility;
  CORBA::Boolean m_registry;
  OTIF::string_S *m_defvalue;
  OTIF::Class_var m_parent;

};

//Class OTIF_Class_i
class  OTIF_Class_i : public virtual POA_OTIF::Class
{
public:
  //Constructor 
  OTIF_Class_i (void);
  
  //Destructor 
  virtual ~OTIF_Class_i (void);
  
  void set_id(CORBA::Long id);
  CORBA::Long get_id();
  void set_name(const char *name);
  CORBA::String_var get_name();
  void set_parent(OTIF::Diagram_var parent);
  void set_stereotype(const char *stereotype);
  void set_isAbstract(CORBA::Boolean isAbstract);
  void set_parentRoles(OTIF::CompositionParentRole_S *parentRoles);
  void set_childRoles(OTIF::CompositionChildRole_S *childRoles);
  void set_associationRoles(OTIF::AssociationRole_S *associationRoles);
  void set_assoc(OTIF::Association_var assoc);
  void set_tagValues(OTIF::TaggedValue_S *tagValues);
  void set_attributes(OTIF::Attrib_S *attributes);
  void set_baseTypes(OTIF::Class_S *baseTypes);
  void set_subTypes(OTIF::Class_S *subTypes);

virtual CORBA::Long tId (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Diagram_ptr parent (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * stereotypeName (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual CORBA::Boolean isAbstract (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual char * name (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::CompositionParentRole_S * parentRoles (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::CompositionChildRole_S * childRoles (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::AssociationRole_S * associationRoles (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Association_ptr assoc (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::TaggedValue_S * tagValues (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Attrib_S * attributes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_S * baseTypes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

virtual ::OTIF::Class_S * subTypes (
    
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ));

private:
  CORBA::Long m_id;
  CORBA::String_var m_name;
  OTIF::Diagram_var m_parent;
  CORBA::String_var m_stereotype;
  CORBA::Boolean m_isAbstract;
  OTIF::CompositionParentRole_S *m_parentRoles;
  OTIF::CompositionChildRole_S *m_childRoles;
  OTIF::AssociationRole_S *m_associationRoles;
  OTIF::Association_var m_assoc;
  OTIF::TaggedValue_S *m_tagValues;
  OTIF::Attrib_S *m_attributes;
  OTIF::Class_S *m_baseTypes;
  OTIF::Class_S *m_subTypes;

};


#endif /* ___BACKPANEL__OTIFI_H_  */
