package org.eclipse.otif.generictooladaptor;

import org.eclipse.swt.*;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.ole.win32.OleFrame;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.ViewPart;

/**
 * @author lang
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Main extends ViewPart implements IViewPart {
	
	public static Backplane backplane;
	private static Layout layout;
	public static String default_subscribed_paradigms = "";
	
    public Main() {}

	public void createPartControl(Composite p) {
		Document.remote_documents = new Document[0];

		Layout.setParent(p);
		
		layout = new Layout(this);
		layout.setPriority(Thread.MIN_PRIORITY);
		layout.start();
		restoreState();

		// Create the ActiveX control frame
		OleFrame frame = new OleFrame(Layout.displayArea, SWT.NONE);
		GridData data = new GridData();
		data.widthHint = 0;
		data.heightHint = 0;
		frame.setLayoutData (data);
		
		backplane = new Backplane(frame, layout);

		String[] args = new String[1];
		args[0] = "";
//		args[0] = Layout.naming_service_text.getText();
		backplane.initialize(args);
//		if (backplane.initialize(args)==0) backplane.default_subscribe(default_subscribed_paradigms);
	}

	public void setFocus() {
		// do nothing		
	}


	// Persistence
	private IMemento memento;
	
	public void init(IViewSite site, IMemento memento) throws PartInitException {
		init(site);
		this.memento = memento;		
	}

	public void saveState(IMemento memento) {
		memento = memento.createChild("tooladaptor_settings");
		memento.putString("working_directory", Layout.working_directory_text.getText());
		memento.putString("notification_check", (Layout.notification_check.getSelection()==true) ? "true" : "false");
//		memento.putString("naming_service", Layout.naming_service_text.getText());
		memento.putString("xslt_script_text", Layout.xslt_script_path);

/*
		String subscribed_paradigms = "";
		for(int i=0; i<Paradigm.remote_paradigms.length; i++) {
			if (Paradigm.remote_paradigms[i].subscribed)
				subscribed_paradigms += Paradigm.remote_paradigms[i].name + '\255' + Paradigm.remote_paradigms[i].version + '\255' + '\255';
		}
		memento.putString("subscribed_paradigms", subscribed_paradigms);
*/
	}

	private void restoreState() {
		if (memento == null) return;
		try {
			memento = memento.getChild("tooladaptor_settings");
			Layout.working_directory_text.setText(memento.getString("working_directory"));
			Layout.notification_check.setSelection((memento.getString("notification_check").equals("true")) ? true : false);
//			Layout.naming_service_text.setText(memento.getString("naming_service"));
			Layout.xslt_script_path = memento.getString("xslt_script_text");

			if (Layout.xslt_script_path.compareTo("null")==0) Layout.xslt_script_path="";
//			default_subscribed_paradigms = memento.getString("subscribed_paradigms");

		} catch (Exception e) {}
		memento = null;
	}
}