/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/

// Fetch_document.cpp : implementation file
//
//#include "UdmHeader.h"
#include "stdafx.h"
#include "Generic_ToolAdaptor.h"
#include "Fetch_document.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString xsl_file_for_fetch;

/////////////////////////////////////////////////////////////////////////////
// Fetch_document dialog


Fetch_document::Fetch_document(CWnd* pParent /*=NULL*/)
	: CDialog(Fetch_document::IDD, pParent)
{
	//{{AFX_DATA_INIT(Fetch_document)
	m_keepalive = _T("");
	m_name = _T("");
	m_paradigm = _T("");
	m_remarks = _T("");
	m_version = _T("");
	m_xslt_file = _T("");
	m_xslt_translation = FALSE;
	//}}AFX_DATA_INIT
}


void Fetch_document::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Fetch_document)
	DDX_Text(pDX, IDC_KEEPALIVE, m_keepalive);
	DDX_Text(pDX, IDC_NAME, m_name);
	DDX_Text(pDX, IDC_PARADIGM, m_paradigm);
	DDX_Text(pDX, IDC_REMARKS, m_remarks);
	DDX_Text(pDX, IDC_VERSION, m_version);
	DDX_Text(pDX, IDC_EDIT3, m_xslt_file);
	DDX_Check(pDX, IDC_CHECK1, m_xslt_translation);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Fetch_document, CDialog)
	//{{AFX_MSG_MAP(Fetch_document)
	ON_BN_CLICKED(IDC_XSLT_SELECTION, OnXsltSelection)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Fetch_document message handlers

void Fetch_document::OnXsltSelection() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	CFileDialog open_dlg(TRUE, "xsl", "", OFN_NOCHANGEDIR);
	open_dlg.m_ofn.lpstrTitle = "Open the XSLT file for post-processing";
	int result = open_dlg.DoModal();
	if (result==IDOK) {

		if (open_dlg.GetFileExt().Compare("xsl")) {
			MessageBox("The file is not a xslt script file!", "Error", MB_OK + MB_ICONEXCLAMATION);
			return;
		}

		m_xslt_file = open_dlg.GetPathName();
		xsl_file_for_fetch = m_xslt_file;
	}

	UpdateData(FALSE);

/*
	CFileDialog open_dlg(TRUE, "xsl", "");
	open_dlg.m_ofn.lpstrTitle = "Open the XSLT file for postprocessing";
	int result = open_dlg.DoModal();
	if (result==IDOK) m_xslt_url = open_dlg.GetPathName();
	else m_xslt_url = "";
*/
}
