// Generic_ToolAdaptor_ActiveXCtl.cpp : Implementation of the CGeneric_ToolAdaptor_ActiveXCtrl ActiveX Control class.

#include "UdmCORBA.h"
#include "stdafx.h"
#include "Generic_ToolAdaptor_ActiveX.h"
#include "Generic_ToolAdaptor_ActiveXCtl.h"
#include "Generic_ToolAdaptor_ActiveXPpg.h"

#include "MainDialog.h"
#include "ta_types_dlg.h"

using namespace UdmCORBA;

extern map<long, PARADIGM_STRUCT> remote_paradigms;
extern list<CONFIG> subscribable;

extern CString xsl_file_for_fetch;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CMainDialog *main_dlg = NULL;
extern long _publishDocument(CString filename);
extern long _subscribeParadigm(CString name, CString version, HWND parent);
extern long _unsubscribeParadigm(CString name, CString version);
extern long _fetchDocument(long subscriptionId, long docId, CString directory, CString filename);
extern long _loginToolAdaptor(CString type);

IMPLEMENT_DYNCREATE(CGeneric_ToolAdaptor_ActiveXCtrl, COleControl)

/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CGeneric_ToolAdaptor_ActiveXCtrl, COleControl)
	//{{AFX_MSG_MAP(CGeneric_ToolAdaptor_ActiveXCtrl)
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_REGISTERED_MESSAGE(wm_Message, OnNotified)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CGeneric_ToolAdaptor_ActiveXCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CGeneric_ToolAdaptor_ActiveXCtrl)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "activateMain", activateMain, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "publishDocument", publishDocument, VT_I4, VTS_BSTR)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "remoteParadigms", remoteParadigms, VT_VARIANT, VTS_NONE)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "subscribeParadigm", subscribeParadigm, VT_I4, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "unsubscribeParadigm", unsubscribeParadigm, VT_I4, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "fetchDocument", fetchDocument, VT_I4, VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "initialize", initialize, VT_I4, VTS_BSTR)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "remoteTypes", remoteTypes, VT_VARIANT, VTS_NONE)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "loginToolAdaptor", loginToolAdaptor, VT_I4, VTS_BSTR)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "getXSLTScriptPath", getXSLTScriptPath, VT_VARIANT, VTS_NONE)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "setXSLTScriptPath", setXSLTScriptPath, VT_I4, VTS_BSTR)
	DISP_FUNCTION(CGeneric_ToolAdaptor_ActiveXCtrl, "getSubscribable", getSubscribable, VT_VARIANT, VTS_NONE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CGeneric_ToolAdaptor_ActiveXCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CGeneric_ToolAdaptor_ActiveXCtrl, COleControl)
	//{{AFX_EVENT_MAP(CGeneric_ToolAdaptor_ActiveXCtrl)
	EVENT_CUSTOM("documentArrived", FireDocumentArrived, VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_I4  VTS_I4  VTS_I4)
	EVENT_CUSTOM("documentChanged", FireDocumentChanged, VTS_BSTR  VTS_BSTR  VTS_BSTR  VTS_I4  VTS_I4  VTS_I4)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CGeneric_ToolAdaptor_ActiveXCtrl, 1)
	PROPPAGEID(CGeneric_ToolAdaptor_ActiveXPropPage::guid)
END_PROPPAGEIDS(CGeneric_ToolAdaptor_ActiveXCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CGeneric_ToolAdaptor_ActiveXCtrl, "GENERICTOOLADAPTORACTIVEX.GenericToolAdaptorActiveXCtrl.1",
	0xeb2f4a, 0x74bb, 0x4cc8, 0x85, 0xd6, 0x56, 0x7, 0xa4, 0x48, 0xa0, 0xa7)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CGeneric_ToolAdaptor_ActiveXCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DGeneric_ToolAdaptor_ActiveX =
		{ 0x665cffee, 0x88a5, 0x4349, { 0x9c, 0xe7, 0x67, 0x36, 0xcc, 0x37, 0xb0, 0x47 } };
const IID BASED_CODE IID_DGeneric_ToolAdaptor_ActiveXEvents =
		{ 0x8dd5724a, 0x94ac, 0x4fd0, { 0x9e, 0x6e, 0x24, 0x84, 0xc3, 0xcd, 0xfb, 0xd8 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwGeneric_ToolAdaptor_ActiveXOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CGeneric_ToolAdaptor_ActiveXCtrl, IDS_GENERIC_TOOLADAPTOR_ACTIVEX, _dwGeneric_ToolAdaptor_ActiveXOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CGeneric_ToolAdaptor_ActiveXCtrl::CGeneric_ToolAdaptor_ActiveXCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CGeneric_ToolAdaptor_ActiveXCtrl

BOOL CGeneric_ToolAdaptor_ActiveXCtrl::CGeneric_ToolAdaptor_ActiveXCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_GENERIC_TOOLADAPTOR_ACTIVEX,
			IDB_GENERIC_TOOLADAPTOR_ACTIVEX,
			afxRegApartmentThreading,
			_dwGeneric_ToolAdaptor_ActiveXOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

/////////////////////////////////////////////////////////////////////////////
// CGeneric_ToolAdaptor_ActiveXCtrl::CGeneric_ToolAdaptor_ActiveXCtrl - Constructor

CGeneric_ToolAdaptor_ActiveXCtrl::CGeneric_ToolAdaptor_ActiveXCtrl()
{
	InitializeIIDs(&IID_DGeneric_ToolAdaptor_ActiveX, &IID_DGeneric_ToolAdaptor_ActiveXEvents);

	// TODO: Initialize your control's instance data here.
	SetControlSize(0, 0);	
}


/////////////////////////////////////////////////////////////////////////////
// CGeneric_ToolAdaptor_ActiveXCtrl::~CGeneric_ToolAdaptor_ActiveXCtrl - Destructor

CGeneric_ToolAdaptor_ActiveXCtrl::~CGeneric_ToolAdaptor_ActiveXCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CGeneric_ToolAdaptor_ActiveXCtrl::OnDraw - Drawing function

void CGeneric_ToolAdaptor_ActiveXCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
//	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
//	pdc->Ellipse(rcBounds);
}


/////////////////////////////////////////////////////////////////////////////
// CGeneric_ToolAdaptor_ActiveXCtrl::DoPropExchange - Persistence support

void CGeneric_ToolAdaptor_ActiveXCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CGeneric_ToolAdaptor_ActiveXCtrl::OnResetState - Reset control to default state

void CGeneric_ToolAdaptor_ActiveXCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CGeneric_ToolAdaptor_ActiveXCtrl::AboutBox - Display an "About" box to the user

void CGeneric_ToolAdaptor_ActiveXCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_GENERIC_TOOLADAPTOR_ACTIVEX);
	dlgAbout.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CGeneric_ToolAdaptor_ActiveXCtrl message handlers

void CGeneric_ToolAdaptor_ActiveXCtrl::activateMain() 
{
	// TODO: Add your dispatch handler code here
	int result = _loginToolAdaptor("");
	if (result==1 || result ==-1) return;

	CMainDialog dlg;
	main_dlg = &dlg;
	dlg.DoModal();

	main_dlg = NULL;
}

long CGeneric_ToolAdaptor_ActiveXCtrl::publishDocument(LPCTSTR filename) 
{
	// TODO: Add your dispatch handler code here
	return _publishDocument(filename);
}

long CGeneric_ToolAdaptor_ActiveXCtrl::subscribeParadigm(LPCTSTR name, LPCTSTR version) 
{
	// TODO: Add your dispatch handler code here
	return _subscribeParadigm(name, version, m_hWnd);
}

long CGeneric_ToolAdaptor_ActiveXCtrl::unsubscribeParadigm(LPCTSTR name, LPCTSTR version) 
{
	// TODO: Add your dispatch handler code here
	return _unsubscribeParadigm(name, version);
}

long CGeneric_ToolAdaptor_ActiveXCtrl::fetchDocument(long subscriptionId, long docId, LPCTSTR directory, LPCTSTR filename) 
{
	// TODO: Add your dispatch handler code here
	return _fetchDocument(subscriptionId, docId, directory, filename);
}

long CGeneric_ToolAdaptor_ActiveXCtrl::loginToolAdaptor(LPCTSTR type) 
{
	// TODO: Add your dispatch handler code here
	return _loginToolAdaptor(type);
}


LRESULT CGeneric_ToolAdaptor_ActiveXCtrl::OnNotified(WPARAM wParam, LPARAM lParam)
{
	if (wParam == 0) {
		MESSAGE_PARAM *message_param = reinterpret_cast<MESSAGE_PARAM *>(lParam);
		FireDocumentArrived((LPCSTR)message_param->name, (LPCSTR)message_param->version, 
			(LPCSTR)message_param->remarks, message_param->keepAlive, 
			message_param->docId, message_param->subscriptionId);
	} else if (wParam == 1) {
		MESSAGE_PARAM *message_param = reinterpret_cast<MESSAGE_PARAM *>(lParam);
		FireDocumentChanged((LPCSTR)message_param->name, (LPCSTR)message_param->version, 
			(LPCSTR)message_param->remarks, message_param->keepAlive, 
			message_param->docId, message_param->subscriptionId);
	}

	return 0;
}

long CGeneric_ToolAdaptor_ActiveXCtrl::initialize(LPCTSTR parameters) 
{
	// TODO: Add your dispatch handler code here
	vector<string> params;
	params.push_back((LPCSTR)parameters);

	try {
		UdmCORBA::corba_startup(params);
	} catch (udmcorba_exception &e) {
		if (e.code() == 5 || e.code() == 6 || e.code() == 7) return e.code();
		MessageBox(e.what(), "Error", MB_OK);
		return 1;
	} catch (udm_exception &e) {
		MessageBox(e.what(), "Error", MB_OK);
		return 1;
	}

	return 0;
}

VARIANT CGeneric_ToolAdaptor_ActiveXCtrl::remoteTypes() 
{
	VARIANT vaResult;
	VariantInit(&vaResult);
	// TODO: Add your dispatch handler code here

	list<string> types;
	CString ta_types = "";
	
	try {
		ToolAdaptor::getBackplaneToolAdaptorTypes(types, 0, NULL);
	} catch (udmcorba_exception &e) {
		MessageBox(e.what(), "Error", MB_OK);
		ta_types = "-1";
	} catch (udm_exception &e) {
		MessageBox(e.what(), "Error", MB_OK);
		ta_types = "-1";
	}

	for(list<string>::iterator i=types.begin(); i!=types.end(); i++) {
		CString item = (CString)(*i).c_str() + "\n";
		ta_types += item;
	}
	
	V_VT(&vaResult) = VT_BSTR;
	vaResult.bstrVal = ta_types.AllocSysString();
	
	return vaResult;
}

VARIANT CGeneric_ToolAdaptor_ActiveXCtrl::remoteParadigms() 
{
	VARIANT vaResult;
	VariantInit(&vaResult);
	// TODO: Add your dispatch handler code here

	CString paradigms = "";

	for(map<long, PARADIGM_STRUCT>::iterator i=remote_paradigms.begin(); i!=remote_paradigms.end(); i++) {
		CString item = (CString)(*i).second.name.c_str() + "\n" + (CString)(*i).second.version.c_str() + "\n\n";
		paradigms += item;
	}
	
	V_VT(&vaResult) = VT_BSTR;
	vaResult.bstrVal = paradigms.AllocSysString();

	return vaResult;
}

VARIANT CGeneric_ToolAdaptor_ActiveXCtrl::getSubscribable() 
{
	VARIANT vaResult;
	VariantInit(&vaResult);
	// TODO: Add your dispatch handler code here

	CString paradigms = "";

	for(list<CONFIG>::iterator i=subscribable.begin(); i!=subscribable.end(); i++) {
		list<PARADIGM_STRUCT> pars = (*i).paradigms;
		for(list<PARADIGM_STRUCT>::iterator j=pars.begin(); j!=pars.end(); j++) {
			CString item = (CString)(*j).name.c_str() + "\n" + (CString)(*j).version.c_str() + "\n\n";
			paradigms += item;
		}
	}
	
	V_VT(&vaResult) = VT_BSTR;
	vaResult.bstrVal = paradigms.AllocSysString();

	return vaResult;
}

VARIANT CGeneric_ToolAdaptor_ActiveXCtrl::getXSLTScriptPath() 
{
	VARIANT vaResult;
	VariantInit(&vaResult);
	// TODO: Add your dispatch handler code here
	
	CString path = xsl_file_for_fetch;

	V_VT(&vaResult) = VT_BSTR;
	vaResult.bstrVal = path.AllocSysString();

	return vaResult;
}

long CGeneric_ToolAdaptor_ActiveXCtrl::setXSLTScriptPath(LPCTSTR path) 
{
	// TODO: Add your dispatch handler code here
	xsl_file_for_fetch = path;

	return 0;
}
