/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/

#ifndef __ToolAdaptorImport__H
#define __ToolAdaptorImport__H

#include <map>

__declspec( dllimport ) int showFetchDlg(const char *label);
__declspec( dllimport ) void addStringFetchDlg(const char *text);
__declspec( dllimport ) void clearFetchDlg();

__declspec( dllimport ) int showPublishDlg(CString *name, CString *version, CString *remarks, 
										   long *keepAlive, CString *filename, 
										   const char* metaName ="",
										   const char* fileextension="*");

__declspec( dllimport ) int showPublishAttachmentDlg(CString *name, CString *version, CString *remarks, 
													 long *keepAlive, CString *filename, std::map<CString, CString> *attachments, const char* fileextension="*");

__declspec( dllimport ) int showDatanetworkArrivedDlg(const char *name, const char *version, const char *remarks,
													  long keepAlive, CString *filename, const char* fileextension="*");


#endif