// matlab.h is created with the udm application from the matlab paradigm

#include "matlab.h"
#include "UdmDom.h"
#include "UdmCORBA.h"
#include "UdmCORBA_Logger.h"
Logger logger("Translator_Test");

using namespace matlab;

class myTranslator : public UdmCORBA::Translator {
public:

	myTranslator(const Udm::UdmDiagram &from_metainfo, const char *from_name, const char *from_version, const Uml::Class &from_rootclass, const Udm::UdmDiagram &to_metainfo, const char *to_name, const char *to_version, const Uml::Class &to_rootclass, int argc, char **argv, Logger *logger) 
       : Translator(from_metainfo, from_name, from_version, from_rootclass, to_metainfo, to_name, to_version, to_rootclass, argc, argv, logger) {};

       // this function is called, when a datanetwork arrives
	void notify(const char *name, const char *version, const char *remarks, const unsigned long numOfDocs);
};

void myTranslator::notify(const char *name, const char *version, const char *remarks, const unsigned long numOfDocs) 
{
  logger->log(1,  "log", "start");
              // Udm specific functions
	*toDN = *fromDN;

              // publish the datanetwork which is in the toDN Translator variable
	publish(name, version, "After the matlab1.0->matlab1.0 translation");
}

int main(int argc, char* argv[]) {
	try {
               // instantiate a translator, the test::diagram variable is defined in the        
               // {paradigm_name}.h (here, test.h), Root::meta is the rootobject's meta 
               // defined in the {paradigm_name}.h (here, test.h)
		myTranslator tr(diagram, "MATLAB", "1.0", Simulink::meta, 
			diagram, " MATLAB", "1.0", Simulink::meta, 
			argc, argv, &logger);
               // run the translator, this is an infinite loop to check the arrived
               // documents and call the notify method
		tr.run();

	} catch (udm_exception &e) {
		cout << e.what() << endl;
		logger.log(1,  "Error", e.what());
	} catch (udmcorba_exception &e) {
		cout << e.what() << endl;
		logger.log(1,  "Error", e.what());
	} catch (...) {
		cerr << "Fatal exception" << endl;
		logger.log(1,  "Error", "Fatal exception");
	}	
	return 0;
}
