// PublishAttachment_DLG.cpp : implementation file
//

#include "stdafx.h"
//#include "ta_mfc_support.h"
#include "PublishAttachment_DLG.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PublishAttachment_DLG dialog


PublishAttachment_DLG::PublishAttachment_DLG(CWnd* pParent /*=NULL*/)
	: CDialog(PublishAttachment_DLG::IDD, pParent)
{
	//{{AFX_DATA_INIT(PublishAttachment_DLG)
	m_name = _T("");
	m_remarks = _T("");
	m_version = _T("");
	m_keepalive = _T("");
	m_time = -1;
	//}}AFX_DATA_INIT
}


void PublishAttachment_DLG::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PublishAttachment_DLG)
	DDX_Control(pDX, IDC_TIME, m_time_control);
	DDX_Control(pDX, IDC_ATTACHMENTS, m_attachments);
	DDX_Text(pDX, IDC_NAME, m_name);
	DDX_Text(pDX, IDC_REMARKS, m_remarks);
	DDX_Text(pDX, IDC_VERSION, m_version);
	DDX_Text(pDX, IDC_KEEPALIVE, m_keepalive);
	DDX_CBIndex(pDX, IDC_TIME, m_time);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PublishAttachment_DLG, CDialog)
	//{{AFX_MSG_MAP(PublishAttachment_DLG)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_CBN_SELCHANGE(IDC_TIME, OnSelchangeTime)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PublishAttachment_DLG message handlers

void PublishAttachment_DLG::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(true);

	for(int i=0; i<m_version.GetLength(); i++) {
		char c = m_version.GetAt(i);
		long l_c = atol(&c);
		if (c!='.' && c!='0' && l_c==0) {
			m_version.Remove(c); 
			i--;
		}
	}

	for(i=0; i<m_keepalive.GetLength(); i++) {
		char c = m_keepalive.GetAt(i);
		long l_c = atol(&c);
		if (c!='0' && l_c==0) {
			m_keepalive.Remove(c); 
			i--;
		}
	}

	UpdateData(false);

	if (m_name.GetLength()==0) {
		MessageBox("You did NOT specify the name of the datanetwork!", "Warning", MB_OK + MB_ICONWARNING);
		return;
	}
	if (m_version.GetLength()==0) {
		MessageBox("You did NOT specify the version of the datanetwork!", "Warning", MB_OK + MB_ICONWARNING);
		return;
	}
	
/*
	long l = atol((LPCSTR)m_keepalive);
	if (l<10) { 
		int result = MessageBox("The keepAlive parameter is too small, so maybe the datanetwork will be destroyed before it can be processed.\n\nContinue?", "Warning", MB_YESNO + MB_ICONQUESTION);
		if (result==IDYES) CDialog::OnOK();
	} else {
		CDialog::OnOK();
	}
*/	

	CDialog::OnOK();
}

BOOL PublishAttachment_DLG::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_time_control.AddString("sec");
	m_time_control.AddString("min");
	m_time_control.AddString("hour");
	
	// default values
	m_version = "1.0";
	m_keepalive = "1";
	UpdateData(false);

	m_time_control.SetCurSel(1);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void PublishAttachment_DLG::OnAdd() 
{
	// TODO: Add your control notification handler code here
	CFileDialog open_dlg(TRUE, "", "", OFN_ALLOWMULTISELECT);
	open_dlg.m_ofn.lpstrTitle = "Select the attachment files";

	// need larger filename buffer to support multiselect
	TCHAR filenameBuffer[16384] = { 0 } ;
	open_dlg.m_ofn.lpstrFile = filenameBuffer;
	open_dlg.m_ofn.nMaxFile = sizeof(filenameBuffer) / sizeof(filenameBuffer[0]);

	int result = open_dlg.DoModal();
	if (result==IDOK) {
		POSITION pos = open_dlg.GetStartPosition();
		while (pos != NULL) {
			CString attachment_file = open_dlg.GetNextPathName(pos);
			int offset = attachment_file.ReverseFind('\\');
			attachments.insert( pair<string, string>( (string)attachment_file.Right(attachment_file.GetLength()-(offset+1)), (string)attachment_file.Left(offset+1) ) );
			m_attachments.AddString(attachment_file.Right(attachment_file.GetLength()-(offset+1)));
		}
	}
}

void PublishAttachment_DLG::OnDelete() 
{
	// TODO: Add your control notification handler code here
	int selected = m_attachments.GetCurSel();
	if (selected != LB_ERR) {
		CString text;
		m_attachments.GetText(selected, text);
		attachments.erase((string)text);
		m_attachments.DeleteString(selected);
	}
}

void PublishAttachment_DLG::OnSelchangeTime() 
{
	// TODO: Add your control notification handler code here
	m_time = m_time_control.GetCurSel();
}
