#pragma warning ( disable : 4666 )

#include "stdafx.h"
#include "ToolAdaptor_Export.h"

#include "Fetch_DLG.h"
#include "Publish_DLG.h"
#include "PublishAttachment_DLG.h"
#include "DatanetworkArrived_DLG.h"

using namespace std;
#include <string>

Fetch_DLG fetch_dlg;

__declspec( dllexport ) int showFetchDlg(const char *label) {
	fetch_dlg.label = label;
	return fetch_dlg.DoModal();
}

__declspec( dllexport ) void addStringFetchDlg(const char *text) {
	fetch_dlg.m_output.AddString(text);
}

__declspec( dllexport ) void clearFetchDlg() {
	fetch_dlg.m_output.ResetContent();
}

__declspec( dllexport ) int showPublishDlg(CString *name, CString *version, CString *remarks, 
										   long *keepAlive, CString *filename, 
										   const char* metaName,
										   const char* fileextension
										   )
 {
	Publish_DLG publish_dlg;
	publish_dlg.m_metaName = metaName;

	int result = publish_dlg.DoModal();
	if (result==IDOK) 
  {
    CString  ext =  CString(metaName) + " Files (*."+ CString(fileextension)+ ")|*." + CString(fileextension)+ "|All Files (*.*)|*.*";
		LPCTSTR szFilter(ext);

		DWORD dwFlags = OFN_FILEMUSTEXIST; 
		CFileDialog open_dlg(TRUE, NULL, NULL,dwFlags,szFilter,NULL);
    //	CFileDialog open_dlg(TRUE, NULL, NULL,dwFlags,NULL,NULL);

//    CFileDialog fileDlg (TRUE, "my", "*.my",
//      OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);


    CString  title = "Select a "+CString(metaName)+ " file to publish";
		open_dlg.m_ofn.lpstrTitle = title;

		result = open_dlg.DoModal();


		*filename = open_dlg.GetPathName();
	}

	*name = publish_dlg.m_name;
	*version = publish_dlg.m_version;
	*remarks = publish_dlg.m_remarks;

	long _keepAlive = atol(publish_dlg.m_keepalive);
	switch (publish_dlg.m_time) {
	case 1 : _keepAlive *= 60; break;
	case 2 : _keepAlive *= 3600; break;
	}
	*keepAlive = _keepAlive;

	return result;
}

__declspec( dllexport ) int showPublishAttachmentDlg(CString *name, CString *version, CString *remarks, 
													 long *keepAlive, CString *filename, std::map<CString, CString> *attachments, const char* fileextension) {

	PublishAttachment_DLG publish_dlg;

	int result = publish_dlg.DoModal();
	if (result==IDOK) {
		CFileDialog open_dlg(TRUE, fileextension, "");
		open_dlg.m_ofn.lpstrTitle = "Select the file to publish";
		result = open_dlg.DoModal();
		*filename = open_dlg.GetPathName();
	}

	*name = publish_dlg.m_name;
	*version = publish_dlg.m_version;
	*remarks = publish_dlg.m_remarks;

	long _keepAlive = atol(publish_dlg.m_keepalive);
	switch (publish_dlg.m_time) {
	case 1 : _keepAlive *= 60; break;
	case 2 : _keepAlive *= 3600; break;
	}
	*keepAlive = _keepAlive;

	attachments->clear();
	for(map<string, string>::iterator i=publish_dlg.attachments.begin(); i!=publish_dlg.attachments.end(); i++) {
		attachments->insert(pair<CString, CString>((*i).first.c_str(), (*i).second.c_str()));
	}

	return result;
}

__declspec( dllexport ) int showDatanetworkArrivedDlg(const char *name, const char *version, const char *remarks,
													  long keepAlive, CString *filename, const char* fileextension) {
	DatanetworkArrived_DLG dnarrived_dlg;

	dnarrived_dlg.m_name = name;
	dnarrived_dlg.m_version = version;
	dnarrived_dlg.m_remarks = remarks;
	char keep[32];
	ltoa(keepAlive, keep, 10);
	string t_keep = keep;
	t_keep += "sec";
	dnarrived_dlg.m_keepalive = t_keep.c_str();
	int result = dnarrived_dlg.DoModal();
	string extension = fileextension;
	string f_name = name;

	if (result==IDOK) {
		CFileDialog *save_dlg;
		if (extension.length()>0 && extension.compare("*")) {
			string name = f_name + ((extension[0]=='.') ? "" : ".") + extension;
			save_dlg = new CFileDialog(FALSE, fileextension, name.c_str());
		} else {
			save_dlg = new CFileDialog(FALSE, fileextension, name);
		}
		result = save_dlg->DoModal();
		*filename = save_dlg->GetPathName();
		delete save_dlg;
	}

	return result;
}
