/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/

#pragma warning( disable : 4518 )

// -*- C++ -*-
//
// $Id: otif_i.cpp,v 1.1 2004/02/12 21:40:05 lang Exp $

// ****  Code generated by the The ACE ORB (TAO) IDL Compiler ****
// TAO and the TAO IDL Compiler have been developed by:
//       Center for Distributed Object Computing
//       Washington University
//       St. Louis, MO
//       USA
//       http://www.cs.wustl.edu/~schmidt/doc-center.html
// and
//       Distributed Object Computing Laboratory
//       University of California at Irvine
//       Irvine, CA
//       USA
//       http://doc.ece.uci.edu/
//
// Information about TAO is available at:
//     http://www.cs.wustl.edu/~schmidt/TAO.html

#include "otif_i.h"
  
// Implementation skeleton constructor
OTIF_ToolAdaptorNotifyCallback_i::OTIF_ToolAdaptorNotifyCallback_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_ToolAdaptorNotifyCallback_i::~OTIF_ToolAdaptorNotifyCallback_i (void)
  {
  }
  
void OTIF_ToolAdaptorNotifyCallback_i::notify (
    const OTIF::NameVersion & documentName,
    const char * remarks,
    OTIF::DocumentID docId,
    CORBA::Long keepAlive,
    CORBA::Long numberOfDocuments
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
    //Add your implementation here
	UdmCORBA::DATANETWORK dn;
	dn.docName = CORBA::string_dup(documentName.name);
	dn.docVersion = CORBA::string_dup(documentName.version);
	dn.remarks = CORBA::string_dup(remarks);
	dn.keepAlive = keepAlive;
	dn.numberOfDocuments = numberOfDocuments;

	datanetwork_repository[docId] = dn;
  }
  
void OTIF_ToolAdaptorNotifyCallback_i::changedExistingDocument (
    const OTIF::NameVersion & documentName,
    const char * remarks,
    OTIF::DocumentID docId,
    CORBA::Long keepAlive,
    CORBA::Long numberOfDocuments
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))
  {
    // Add your implementation here
	UdmCORBA::DATANETWORK dn;
	dn.docName = CORBA::string_dup(documentName.name);
	dn.docVersion = CORBA::string_dup(documentName.version);
	dn.remarks = CORBA::string_dup(remarks);
	dn.keepAlive = keepAlive;
	dn.numberOfDocuments = numberOfDocuments;

	changed_datanetwork_repository[docId] = dn;
  }

  
// Implementation skeleton constructor
OTIF_TranslatorNotifyCallback_i::OTIF_TranslatorNotifyCallback_i (void)
  {
  }
  
// Implementation skeleton destructor
OTIF_TranslatorNotifyCallback_i::~OTIF_TranslatorNotifyCallback_i (void)
  {
  }
  
void OTIF_TranslatorNotifyCallback_i::notify (
    const OTIF::NameVersion & documentName,
    OTIF::DocumentID docId,
    CORBA::Long keepAlive,
    CORBA::Long numberOfDocuments
  )
  ACE_THROW_SPEC ((
    CORBA::SystemException
  ))

  {
	//Add your implementation here
	UdmCORBA::DATANETWORK dn;
	dn.docName = CORBA::string_dup(documentName.name);
	dn.docVersion = CORBA::string_dup(documentName.version);
	dn.remarks = "";
	dn.keepAlive = keepAlive;
	dn.numberOfDocuments = numberOfDocuments;	

	datanetwork_repository[docId] = dn;
  }
